#ifndef __SIGNAL_H__
#define __SIGNAL_H__
#ifdef __cplusplus
extern "C" {
#endif
#ident "$Revision: 1.47 $"
/*
*
* Copyright 1992-1996 Silicon Graphics, Inc.
* All Rights Reserved.
*
* This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics, Inc.;
* the contents of this file may not be disclosed to third parties, copied or
* duplicated in any form, in whole or in part, without the prior written
* permission of Silicon Graphics, Inc.
*
* RESTRICTED RIGHTS LEGEND:
* Use, duplication or disclosure by the Government is subject to restrictions
* as set forth in subdivision (c)(1)(ii) of the Rights in Technical Data
* and Computer Software clause at DFARS 252.227-7013, and/or in similar or
* successor clauses in the FAR, DOD or NASA FAR Supplement. Unpublished -
* rights reserved under the Copyright Laws of the United States.
*/
/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*
 * WARNING - this is an ANSI/POSIX/XPG4 header. In ANSI mode only
 * ANSI symbols are permitted
 */
#include <standards.h>
#include <sys/signal.h>

#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)
/* ANSI */
typedef int 	sig_atomic_t;
extern int raise(int);

#if _POSIX90 && _NO_ANSIMODE

#if !defined(_BSD_COMPAT) && !defined(_BSD_SIGNALS) 
extern int kill(pid_t, int);
#endif /* !BSD */
extern int sigaction(int, const struct sigaction *, struct sigaction *);
extern int sigpending(sigset_t *);
extern int sigprocmask(int, const sigset_t *, sigset_t *);
extern int sigsuspend(const sigset_t *);
extern int sigaddset(sigset_t *, int);
extern int sigdelset(sigset_t *, int);
extern int sigemptyset(sigset_t *);
extern int sigfillset(sigset_t *);
extern int sigismember(const sigset_t *, int);
#endif	/* _POSIX90 */

#if  _POSIX93 && _NO_ANSIMODE
/*
 * POSIX1003.1b additions
 */
struct timespec;

extern int sigqueue(pid_t , int, const union sigval);
extern int sigwaitinfo(const sigset_t *, struct siginfo *);
extern int sigtimedwait(const sigset_t *, struct siginfo *, struct timespec *);
extern int sigwait(const sigset_t *, int *);
#endif /* _POSIX93 */

#if _XOPEN4UX && _NO_ANSIMODE
/*
 * XOPEN with UX extensions
 */
#if !defined(_BSD_COMPAT) && !defined(_BSD_SIGNALS) 
extern int sigpause(int);
#endif /* !BSD */
extern __sigret_t (*sigset(int,__sigret_t (*)(__sigargs)))(__sigargs);

extern int sighold(int);
extern int sigrelse(int);
extern int sigignore(int);
extern int siginterrupt(int, int);
extern int sigaltstack(const stack_t *, stack_t *);
#endif /* _XOPEN4UX */

#if _SGIAPI
extern char *_sys_siglist[];
extern int _sys_nsig;

#include <sys/types.h>
#include <sys/procset.h>
extern int (*ssignal(int, int (*)(int)))(int);
extern int gsignal(int);
extern int sigsend(idtype_t, id_t, int);
extern int sigsendset(const procset_t *, int);

/*
 * The signal-masking routine sgi_altersigs() contains an action 
 * parameter; the routine can either add or delete a set of signals.
 */
#define ADDSIGS         1
#define DELSIGS         2

/*
 * The following macro returns true if any of the signals in the sigset_t
 * pointed to by "setptr" are set.
 */
#define sgi_siganyset(setptr)   (sgi_sigffset(setptr,0) != 0)

extern int sgi_altersigs(int, sigset_t *, int[]);
extern int sgi_sigffset(sigset_t *, int);
extern int sgi_dumpset(sigset_t *);

#endif 	/* _SGIAPI */

#endif  /* _LANGUAGE_C */
#ifdef __cplusplus
}
#endif
#if defined(__cplusplus) || defined(__USE_FIXED_PROTOTYPES__)
#ifdef __cplusplus
extern "C" {
#endif
extern int kill (long , int);
#ifdef __cplusplus
}
#endif
#endif /* defined(__cplusplus) || defined(__USE_FIXED_PROTOTYPES__*/
#endif /* !__SIGNAL_H__ */
